module doodle.dia.page_layer;

public {
    import doodle.dia.icanvas;
}

private {
    import doodle.tk.cairo;
}

class PageLayer : Layer, IPage {
    this(in string name = "Page") {
        super(name);
        _pageGeometry = Rectangle(Point.DEFAULT, Vector(210.0, 297.0));
        //_pageGeometry = Rectangle(Point.DEFAULT, Vector(100.0, 100.0));
    }

    // Layer overrides:

    override Rectangle bounds() const {
        return _pageGeometry;
    }

    override void draw(in Rectangle pixelDamage, scope Context pixelCr,
                       in Rectangle modelDamage, scope Context modelCr) const {
        // Make the paper white, with a border

        modelCr.save; {
            modelCr.setSourceRgba(0.0, 0.0, 0.0, 1.0);
            rectangle(modelCr, _pageGeometry);
            modelCr.stroke;
        } modelCr.restore;

        modelCr.save; {
            modelCr.setSourceRgba(1.0, 1.0, 1.0, 1.0);
            rectangle(modelCr, _pageGeometry);
            modelCr.fill;
        } modelCr.restore;
    }

    // IPage overrides:

    private {
        Rectangle _pageGeometry;
    }
}
